<%- include('../partials/header', {title: 'Seznam uživatelů'}); %>
<!-- Datatables styles -->
<link rel="stylesheet" href="/assets/vendor/datatables.net-bs4/css/dataTables.bootstrap4.min.css">
<link rel="stylesheet" href="/assets/vendor/datatables.net-buttons-bs4/css/buttons.bootstrap4.min.css">
<link rel="stylesheet" href="/assets/vendor/datatables.net-select-bs4/css/select.bootstrap4.min.css">
<%- include('../partials/scripts'); %>
</head>

<body class="">
  <%- include('../partials/navbar', {active: 'users'}); %>
  <div class="main-content">
    <%- include('../partials/topbar', {title: 'Seznam uživatelů'}) %>
    <%- include('partials/header-bar') %>
    <div class="container-fluid mt--7">
      <%
      if (req.query.status) {
        switch (req.query.status) {
        case 'new-ok':
          bg = `success`;
          text = {
            bold: 'Gratuluji!',
            normal: 'Uživatel byl úspěšně vytvořen!',
          }; 
          break;
      
        case 'user-edit-ok':
          bg = `success`;
          text = {
            bold: 'Gratuluji!',
            normal: 'Uživatel byl úspěšně upraven!',
          }; 
          break;

        default:
          bg = `default`;
          text = {
            bold: 'Heleme se!',
            normal: ' Uživatel si hraje s URL!',
          };
          break;
      }
      %>
      <div class="alert alert-<%= bg %>" role="alert">
        <strong><%= text.bold %></strong> <%= text.normal %>
      </div>
      <% } %>
      <div class="row">
        <div class="col">
          <div class="card shadow">
            <div class="card-header border-0">
              <h3 class="mb-0">Seznam uživatelů</h3>
            </div>
            <div class="card-body">
              <div class="table-responsive">
                <div>
                  <table class="table align-items-center" id="myTable">
                    <thead class="thead-light">
                      <tr>
                        <th scope="col">Jméno</th>
                        <th scope="col">Uživatelské jméno</th>
                        <th scope="col">Email</th>
                        <th scope="col">Práva</th>
                        <th scope="col">Vytvořil</th>
                        <th scope="col">Poslední přihlášení</th>
                        <th scope="col">Akce</th>
                      </tr>
                    </thead>
                    <tbody class="list">
                      <% users.forEach((user) => { %>
                      <tr>
                        <th scope="row" class="name">
                          <div class="media align-items-center">
                            <a href="#" class="avatar rounded-circle mr-3">
                              <img alt="Profile photo" src="<%= user.photoUrl %>">
                            </a>
                            <div class="media-body">
                              <span class="mb-0 text-sm">
                                <%= user.name.first %> <%= user.name.last %>
                              </span>
                            </div>
                          </div>
                        </th>
                        <td><%= user.username %></td>
                        <td><%= user.email %></td>
                        <td>
                          <% if (user.permissions.includes('masterAdmin')){ %>
                          masterAdmin
                          <% } else { %>
                          <%= user.permissions %>
                          <% } %>
                        </td>
                        <td><%= user.author == null ? 'Sám sebe' : user.author  %></td>
                        <td>
                          <%= user.logins.length == 0 ? 'Nikdy, to je ale smutné' : moment(user.logins[user.logins.length-1].time).format('DD. MM. YYYY HH:m:s') %>
                        </td>
                        <td>
                          <div class="row" style="justify-content: space-between; /*min-width: 80px;*/">
                            <% if (req.session.user.permissions.includes('users-edit') || req.session.user.permissions.includes('masterAdmin')){ %>
                            <a href="/admin/users/edit/?id=<%= user._id %>">
                              <i class="fas fa-pen"></i></a>
                            <% } if (req.session.user.permissions.includes('users-delete') || req.session.user.permissions.includes('masterAdmin')){ %>
                            <button onclick="deleteUserById('<%= user._id %>');"
                              style="background: none; border: none; padding: 0; ">
                              <i class="fas fa-trash" style="color: red; "></i>
                            </button>
                            <% } if (req.session.user.permissions.includes('email') || req.session.user.permissions.includes('masterAdmin')){ %>
                            <a href="/admin/email/write?recipient=<%= user.email %>" alt="Poslat email uživateli">
                              <i class="fas fa-envelope" style="color: grey; "></i>
                            </a>
                            <% } if (req.session.user.permissions.includes('users-change-password') || req.session.user.permissions.includes('masterAdmin')){ %>
                            <button onclick="changeUserPasswordById('<%= user._id %>');"
                              style="background: none; border: none; padding: 0; ">
                              <i class="fas fa-key" style="color: black; "></i>
                            </button>
                            <% } %>
                          </div>
                        </td>
                      </tr>
                      <%}); %>
                    </tbody>
                  </table>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <%- include('../partials/footer') %>
      <!-- Optional JS -->
      <script src="//cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
      <script src="/assets/vendor/datatables.net/js/jquery.dataTables.min.js"></script>
      <script src="/assets/vendor/datatables.net-bs4/js/dataTables.bootstrap4.min.js"></script>
      <script src="/assets/vendor/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
      <script src="/assets/vendor/datatables.net-buttons-bs4/js/buttons.bootstrap4.min.js"></script>
      <script src="/assets/vendor/datatables.net-buttons/js/buttons.html5.min.js"></script>
      <script src="/assets/vendor/datatables.net-buttons/js/buttons.flash.min.js"></script>
      <script src="/assets/vendor/datatables.net-buttons/js/buttons.print.min.js"></script>
      <script src="/assets/vendor/datatables.net-select/js/dataTables.select.min.js"></script>
      <script>
        $(document).ready(function () {
          $('#myTable').DataTable();
        });

        function changeUserPasswordById(id) {
          swal({
            title: 'Opravdu chceš změnit heslo tohoto uživatele?',
            text: 'Radši si to dvakrát rozmysli',
            icon: 'warning',
            content: {
              element: "input",
              attributes: {
                placeholder: "Zde napiš nové heslo",
                type: "password",
              },
            },
            buttons: {
              cancel: "Neee, byl to omyl",
              confirm: 'Změň to!',
            },
          }).then((newPassword) => {
            if (newPassword) {
              $.post({
                url: `/admin/users/set-new-password/`,
                data: {
                  id,
                  newPassword,
                },
                success: function (response) {
                  console.log(response);
                  switch (response) {
                    case 'ok':
                      swal({
                        title: 'Heslo bylo změněno!',
                        text: 'Email s heslem mu byl odeslán, tak snad ho uživatel už nezapomene.',
                        icon: 'success',
                        timer: 5000,
                      }).then((value) => {
                        //window.location.href = '/admin/dashboard/';
                        location.reload();
                      });
                      break;

                    case 'not-sent-password':
                      swal({
                        title: 'Heslo nebylo změněno!',
                        text: 'Nastala chyba, protože jsi neposlal na server heslo, které chceš uživateli nastavit.',
                        icon: 'error',
                      });
                      break;

                    case 'not-sent-id':
                      swal({
                        title: 'Heslo nebylo změněno!',
                        text: 'Nastala chyba, protože jsi neposlal na server ID uživatele, kterému chceš změnit heslo.',
                        icon: 'error',
                      });
                      break;

                    default:
                      swal({
                        title: 'Něco se pokazilo!',
                        text: `Ozvi se Lukynovi, server říká: ${response}"`,
                        icon: 'error',
                      });
                      break;
                  }
                }
              });
            }
          });
        }

        function deleteUserById(id) {
          swal({
            title: 'Opravdu chceš smazat tohoto uživatele?',
            text: 'Radši si to dvakrát rozmysli',
            icon: 'warning',
            timer: 5000,
            dangerMode: true,
            buttons: {
              cancel: "Neee, byl to omyl",
              confirm: 'Změn to!',
            },
          }).then((confirm) => {
            if (confirm) {
              $.post({
                url: `/admin/users/delete/`,
                data: {
                  id,
                },
                success: function (response) {
                  console.log(response);
                  switch (response) {
                    case 'ok':
                      swal({
                        title: 'Uživatel byl smazán!',
                        text: 'Už ho nikdy neuvidíme.',
                        icon: 'success',
                        timer: 5000,
                      }).then((value) => {
                        //window.location.href = '/admin/dashboard/';
                        location.reload();
                      });
                      break;

                    case 'not-sent-id':
                      swal({
                        title: 'Uživatel se nesmazal!',
                        text: 'Nastala chyba, protože jsi neposlal na server ID uživatele, kterého chceš smazat.',
                        icon: 'error',
                      });
                      break;

                    default:
                      swal({
                        title: 'Něco se pokazilo!',
                        text: `Ozvi se Lukynovi, server říká: ${response}"`,
                        icon: 'error',
                      });
                      break;
                  }
                }
              });
            }
          });
        }
      </script>
    </div>
  </div>




  <%- include('../partials/file-end') %>